ames = read.csv("ames.csv", stringsAsFactors = F)
# drop variables with missing obs
ames = ames[sapply(ames, function(x) !any(is.na(x)))] # selects variables with complete obs 
sapply(ames, function(x) sum(is.na(x)))
##
str(ames) 
###########################################################
Ntot = nrow(ames)
set.seed(28021999); # set seed here by inserting your matricola (here 28021999)
N = 1000;
s = sample(1:Ntot, N);
ames.train = ames[s,];
# training sample of size N
ames.test = ames[-s,];
# test sample of size Ntot-N
summary(ames.train);
attach(ames.train)
###########################################################
hist(SalePrice, 50)
hist(log(SalePrice), 50)
boxplot(SalePrice~ factor(BldgType))
boxplot(SalePrice~ factor(OverallQual))
boxplot(SalePrice~ factor(HouseStyle))
# conditional means and variances
cmeans = tapply(SalePrice,HouseStyle,mean)
cvar   = tapply(SalePrice,HouseStyle,var)
cv = sqrt(cvar)/cmeans   # coefficient of variation
X =  data.frame(SalePrice, x1stFlrSF,x2ndFlrSF, TotalBsmtSF, GrLivArea, YearBuilt) 
pairs(X)
cov(X)
cor(X)
###########################################################
y = SalePrice
x =  x1stFlrSF+ x2ndFlrSF+TotalBsmtSF
#############################################
m0 = lm(y~ x)
summary(m0)
plot(x, y)
abline(m0, col = 'red')
# drop observations with high leverage 
sel = which(x > 6000, arr.ind=TRUE)
ys = y[-sel]
xs = x[-sel]
m0s = lm(ys ~ xs)
summary(m0s)
plot(xs, ys)
abline(m0s, col = 'red')
e0s = residuals(m0s)
 
m1 = lm(y~ x+I(x^2))
summary(m1)
plot(x,  fitted(m1))

m1s = lm(ys~ xs+I(xs^2))
summary(m1s)
plot(xs,  fitted(m1s))
  